#include <gtk/gtk.h>

enum OP {NOP, ADD, SUB, MUL, DIV};

typedef struct _calc{
  glong    buffer;
  glong    acc;
  gint     op;
  gboolean first;
}Calc;

void calc_reset(Calc *cal);


Calc* calc_new(){
  Calc* cal = (Calc*) malloc (sizeof(Calc));
  calc_reset(cal);
  return cal;			       
}

void calc_reset(Calc *cal){
  cal->buffer = 0;
  cal->acc    = 0;
  cal->op     = NOP;
  cal->first  = TRUE;
}


void calc_add_digit(Calc *cal, int digit){
  if (cal->first == TRUE){
    cal->buffer = digit ;
  }
  else{
    cal->buffer = (cal->buffer * 10) + digit;
  }
  cal->first = FALSE;
}


void calc_do_op(Calc *cal){
  switch (cal->op){
  case ADD:
    cal->acc = cal->acc + cal->buffer;
    break;
  case SUB:
    cal->acc = cal->acc - cal->buffer; 
    break;
  case MUL:
    cal->acc = cal->acc * cal->buffer; 
    break;
  case DIV:
    cal->acc = cal->acc / cal->buffer; 
    break;
  default:
    cal->acc = cal->buffer;
  }

  cal->first  = TRUE;
  cal->op     = NOP ;
  cal->buffer = 0   ;
  
}

void calc_set_add(Calc *cal){
  calc_do_op(cal);
  cal->op = ADD;
}


void calc_set_sub(Calc *cal){
  calc_do_op(cal);
  cal->op = SUB;
}

void calc_set_mul(Calc *cal){
  calc_do_op(cal);
  cal->op = MUL;
}

void calc_set_div(Calc *cal){
  calc_do_op(cal);
  cal->op = DIV;
}

void calc_set_eq(Calc *cal){
  calc_do_op(cal);
  cal->buffer = cal->acc;
  cal->acc = 0;
}

glong calc_get_buffer(Calc *cal){
  return (cal->buffer);
}
